
;**************************************
;     SOFTWARE FOR ET_BOARD VER 4.0   *
;             DISPLAY 8*20            *
;          EXAMPLE PROGRAM 02         *
;**************************************
;

           CPU "Z80.TBL"
           HOF "INT8"

           ORG 2000H

PSCAN:     EQU  21H
DATA:      EQU  20H
CLK:       EQU  22H
CTRL:      EQU  23H
NDSP:      EQU  8
;
;
;***********************
;     MAIN PROGRAM     *
;***********************

MAIN:  LD   A,80H
       OUT  (CTRL),A
       CALL MIR
MAIN1: CALL SCAND
       JR   MAIN1
;
;
;***********************
;      SCAN DISPLAY    *
;***********************

SCAND: LD   IY,TSL
       LD   HL,DISBUF
       LD   D,20

SCAN1: PUSH HL
       LD   E,NDSP
       LD   C,0
       CALL CLEAR
       LD   A,(IY+0)
       OUT  (PSCAN),A
;
SCAN2: LD   A,(HL)
       OUT  (DATA),A
       CALL PULSE
;
       INC  C
       PUSH BC
       LD   BC,24
       ADD  HL,BC
       POP  BC
       DEC  E
       JR   NZ,SCAN2
;
       POP  HL
       INC  HL
       INC  IY
       CALL DEL            ;delay of row
       DEC  D
       JR   NZ,SCAN1
       RET
;
;***********************
;   CLEAR 74LS374 SUB. *
;***********************

CLEAR: PUSH BC
       LD   C,0
       LD   B,NDSP
CLR1:  XOR  A
       OUT  (DATA),A
       CALL PULSE
       INC  C
       DJNZ CLR1
       POP  BC
       RET
;
;***********************
;   CLOCK 74LS374 SUB. *
;***********************

PULSE: LD   A,C
       SLA  A
       OUT  (CTRL),A
       OR   1
       OUT  (CTRL),A
       RET

;
;***********************
;       DELAY SUB.     *
;***********************
;
DEL:   PUSH AF
       LD   A,5
DEL1:  DEC  A
       JR   NZ,DEL1
       POP  AF
       RET
;
;***********************
;    MIRROR CHARACTER  *
;***********************

MIR:   LD   HL,ASCII
       LD   IX,DISBUF
       LD   D,NDSP              ;NUM IS CONVERT
MIR1:  CALL MIR_S
       DEC  D
       JR   NZ,MIR1
       RET
;
;***********************
;   MIRROR 1 CHARACTER *
;***********************

MIR_S:  LD   C,24
MIR_S1: LD   B,8
MIR_S2: RLC  (HL)
        RR   A
        DJNZ MIR_S2
        LD   (IX+0),A
        INC  HL
        INC  IX
        DEC  C
        JR   NZ,MIR_S1
        RET


TSL:     DFB   0F0H,0F1H,0F2H,0F3H,0F4H
         DFB   0F5H,0F6H,0F7H,0F8H,0F9H
         DFB   0FH,1FH,2FH,3FH,4FH
         DFB   5FH,6FH,7FH,8FH,9FH

;
ASCII:   DFB   00H,00H,00H,00H,00H,00H,00H,10H      ;1
         DFB   30H,10H,10H,10H,10H,10H,10H,38H
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,3CH      ;2
         DFB   42H,02H,02H,04H,08H,10H,20H,7EH
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,3CH      ;3
         DFB   42H,02H,02H,1CH,02H,02H,42H,3CH
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,04H      ;4
         DFB   0CH,14H,24H,44H,84H,0FEH,04H,04H
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,0FCH     ;5
         DFB   80H,80H,0F8H,84H,02H,02H,84H,78H
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,1CH      ;6
         DFB   20H,40H,40H,7CH,42H,42H,42H,3CH
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,7EH      ;7
         DFB   42H,02H,04H,04H,08H,08H,10H,10H
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

         DFB   00H,00H,00H,00H,00H,00H,00H,3CH      ;8
         DFB   42H,42H,42H,3CH,42H,42H,42H,3CH
         DFB   00H,00H,00H,00H,00H,00H,00H,00H

      ORG  3500H

DISBUF:

  END
