
;**************************************
;     SOFTWARE FOR ET_BOARD VER 4.0   *
;              DISPLAY 8*20           *
;           EXAMPLE PROGRAM 05        *
;**************************************
;

           CPU "Z80.TBL"
           HOF "INT8"

           ORG 2000H

PSCAN:     EQU  21H
DATA:      EQU  20H
CLK:       EQU  22H
CTRL:      EQU  23H
NDSP:      EQU  8
N_CHR:     EQU  13
BLOCK:     EQU  24*N_CHR
;
;
;***********************
;     MAIN PROGRAM     *
;***********************

MAIN:   LD   A,80H
        OUT  (CTRL),A
        NOP
        NOP
        NOP
        NOP
        NOP
        LD   A,0FFH
        OUT  (CLK),A
        LD   BC,BLOCK       ;Clear buffer character
        LD   HL,DISBUF
        LD   DE,DISBUF+1
        LD   (HL),0
        LDIR
        CALL CLRDSP         ;Clear buffer screen
        CALL MIR
;
MAIN8:  LD   HL,CHAR

MAIN7:
        CALL CLRDSP
        CALL CONV           ;Change ascii for key to font display
MAIN1:
        CALL SHTL           ;LED shift left
        JR   MAIN1
;
;***********************
; DISPLAY LEFT & RIGHT *
;***********************
;
DSP_LR:
        PUSH BC
        LD   B,5            ;repeat scan display 5 round
DSP_LR1:
        CALL SCAND
        DJNZ DSP_LR1
        POP  BC
        RET
;
;
;***********************
;      SCAN DISPLAY    *
;***********************

SCAND:  PUSH AF
        PUSH BC
        PUSH DE
        PUSH HL
        PUSH IY
;
;/* scan display 5 digit */

        LD   IY,TSL
        LD   D,3         ;
        LD   HL,DISPY
        LD   (B_DSP),HL

SCAND1: LD   B,8
SCAND2: LD   A,NDSP
        LD   (B_NUM),A
        CALL CLEAR
        LD   C,0
;
SCAND3: PUSH HL
        LD   A,(IY+0)
        OUT  (PSCAN),A
;
        LD   E,8            ;8 bit of column is convert
SCAND4: RRC  (HL)           ;
        RRA                 ;data to convert
        DEC  E
        INC  HL
        JR   NZ,SCAND4
;
        OUT  (DATA),A
        CALL PULSE
;
        INC  C
        POP  HL
        PUSH BC
        LD   BC,24
        ADD  HL,BC
        POP  BC
        LD   A,(B_NUM)
        DEC  A
        LD   (B_NUM),A
        JR   NZ,SCAND3
;
        LD   A,(IY+0)
        CP   9FH
        JP   Z,SCANDE
        INC  IY
        CALL DEL            ;delay of row
        LD   HL,(B_DSP)
        DJNZ SCAND2

        LD   BC,8
        LD   HL,(B_DSP)
        ADD  HL,BC
        LD   (B_DSP),HL
        DEC  D
        JR   NZ,SCAND1

SCANDE: POP  IY
        POP  HL
        POP  DE
        POP  BC
        POP  AF
        RET
;
;***********************
;     CLOCK 74LS374    *
;***********************

PULSE:  LD   A,C
        SLA  A
        OUT  (CTRL),A
        OR   1
        OUT  (CTRL),A
        RET
;
;***********************
;  CLEAR DATA 74LS374  *
;***********************

CLEAR:  PUSH BC
        LD   C,0
        LD   B,NDSP
;
CLEAR1: XOR  A               ;CLEAR
        OUT  (DATA),A
        CALL PULSE
        INC  C
        DJNZ CLEAR1
;
        POP  BC
        RET
;
;***********************
;       DELAY SUB.     *
;***********************
;
DEL:    PUSH AF
        LD   A,1
DEL1:   DEC  A
        JR   NZ,DEL1
        POP  AF
        RET
;
;***********************
;   CLEAR DISPLAY BUF  *
;***********************
;
CLRDSP: PUSH HL
        LD  HL,DISPY
        LD  BC,BLOCK
        LD  DE,DISPY+1
        LD  (HL),0
        LDIR
        POP  HL
        RET
;
;
;***********************
;   shift left display *
;***********************
;
SHTL:   CALL GLENT
        LD   IX,DISBUF

SHTL00: LD   A,8
        LD   (BUF_8),A

SHTL0:  LD   D,0
        LD   E,0
        LD   HL,8*NDSP       ;BLOCK
        OR   A
        SBC  HL,BC
        JP   NC,SHTL1
        LD   E,0FFH
        LD   D,(IX+0)
;
SHTL1:  LD   HL,DISPY+8-1

        PUSH BC
        PUSH IX

        CALL ROTATE
        LD   HL,DISPY+24+8-1
        CALL NEXT
        CALL SADD

        LD   A,E
        CP   0
        JR   NZ,SHTL2
        LD   D,0

SHTL2:  LD   HL,DISPY+16-1
        CALL ROTATE
;
        LD   HL,DISPY+24+16-1
        CALL NEXT
        CALL SADD

        LD   A,E
        CP   0
        JR   NZ,SHTL3
        LD   D,0

SHTL3:  LD   HL,DISPY+24-1
        CALL ROTATE

        LD   HL,DISPY+24+24-1
        CALL NEXT

        CALL DSP_LR

        POP  IX
        POP  BC

        INC  IX
        DEC  BC
        LD   A,B
        OR   C
        JR   Z,SHTLE
;
        LD   A,(BUF_8)
        DEC  A
        LD   (BUF_8),A
        JP   NZ,SHTL0
;
        PUSH IX
        POP  HL
        LD   DE,16
        ADD  HL,DE
        PUSH HL
        POP  IX
        JP   SHTL00

SHTLE:  RET
;
;***********************
;    ROTATE NEXT CHR.  *
;***********************

NEXT:   PUSH BC
        LD   B,NDSP-1
NEXT1:  PUSH HL
        CALL ROTATE
        POP  HL
        PUSH DE
        LD   DE,24
        ADD  HL,DE
        POP  DE
        DJNZ NEXT1
        POP  BC
        RET
;
;***********************
;     ROTATE 1 CHAR.   *
;***********************

ROTATE: PUSH BC
        LD   B,8
ROTAT1: LD   A,(HL)
        LD   (HL),D
        LD   D,A
        DEC  HL
        DJNZ ROTAT1
        POP  BC
        RET
;
;***********************
; NEXT CHAR OF DIS_BUF *
;***********************

SADD:   PUSH HL
        PUSH IX
        POP  HL
        LD   A,L
        ADD  A,8
        LD   L,A
        LD   A,H
        ADC  A,0
        LD   H,A
        LD   D,(HL)

SADD1:  PUSH HL
        POP  IX
        POP  HL
        RET


;***********************
;       GET LENGTH     *
;***********************
;
GLENT:  LD   HL,8*N_CHR
        LD   DE,8*NDSP
        ADD  HL,DE
        PUSH HL
        POP  BC
        RET
;
;***********************
;      FONT CONVERT    *
;***********************
;
FONT_COV:
        PUSH IY
        PUSH DE
        PUSH AF

        LD   DE,CHR_BUF
        LD   BC,24
        LDIR
;
        LD   IY,CHR_BUF1
        LD   E,3

FONT_1: LD   HL,CHR_BUF
FONT_2: LD   B,8

FONT_3: PUSH HL
        LD   C,8

FONT_31:
        RRC  (HL)
        RR   D
        INC  HL
        DEC  C
        JR   NZ,FONT_31

        LD   (IY+0),D
        INC  IY

        POP  HL
        DEC  B
        JR   NZ,FONT_3
;
        LD   BC,8
        ADD  HL,BC
        DEC  E
        JR   NZ,FONT_2

        POP  AF
        POP  DE
        POP  IY
        LD   HL,CHR_BUF1
        RET
;
;***********************
;     CONVERT CHAR.    *
;***********************

CONV:   LD   DE,DISBUF
        LD   B,N_CHR              ;NUM OF CHARACTER
CONV1:  PUSH BC
        PUSH HL
        CALL FONT_COV
        LD   BC,24
        LDIR
;
        POP  HL
        LD   BC,24
        ADD  HL,BC
        POP  BC
        DJNZ CONV1
        RET
;
;***********************
;     MIRROR CHAR.     *
;***********************

MIR:    LD   HL,CHAR
        LD   D,N_CHR             ;NUM IS CONVERT
MIR1:   CALL MIR_S
        DEC  D
        JR   NZ,MIR1
        RET
;
;***********************
;      MIRROR SUB.     *
;***********************

MIR_S:  LD   C,24
MIR_S1: LD   B,8
MIR_S2: RLC  (HL)
        RR   A
        DJNZ MIR_S2
        LD   (HL),A
        INC  HL
        DEC  C
        JR   NZ,MIR_S1
        RET

;
;/* SCAN TABLE */

TSL:       DFB   0F0H,0F1H,0F2H,0F3H,0F4H
           DFB   0F5H,0F6H,0F7H,0F8H,0F9H
           DFB   0FH,1FH,2FH,3FH,4FH
           DFB   5FH,6FH,7FH,8FH,9FH

;
CHAR:      DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   0C4H,0AAH,52H,62H,42H,42H,42H,42H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   3CH,42H,42H,52H,6AH,5AH,4AH,72H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,02H,04H
           DFB   7CH,82H,02H,3AH,46H,62H,52H,22H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   7CH,0C2H,02H,22H,52H,62H,42H,7CH
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   42H,0A2H,62H,22H,22H,22H,22H,7EH
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   31H,12H,3CH,00H,00H,00H,00H,00H
           DFB   24H,54H,34H,14H,14H,14H,14H,18H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   7CH,0C2H,02H,22H,52H,62H,42H,7CH
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   42H,0A2H,62H,22H,22H,7AH,0A6H,62H
           DFB   00H,1AH,0AH,0EH,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   7CH,82H,02H,3AH,46H,62H,52H,22H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,8CH,54H,24H,04H
           DFB   04H,04H,04H,04H,04H,06H,05H,02H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,02H,02H,02H
           DFB   42H,0A2H,62H,22H,2AH,2AH,36H,22H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   02H,02H,02H,00H,3CH,42H,7EH,00H
           DFB   3CH,42H,02H,02H,02H,06H,0AH,04H
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
;
           DFB   00H,00H,00H,00H,00H,00H,00H,00H
           DFB   08H,14H,0CH,04H,44H,24H,14H,0CH
           DFB   00H,00H,00H,00H,00H,00H,00H,00H

;

           ORG  3500H

DISBUF:    DFS   24*30
DISPY:     DFS   24*NDSP
CHR_BUF:   DFS   24
CHR_BUF1:  DFS   24
B_NUM:     DFS   1
BUF_8:     DFS   2
B_DSP:     DFS   2
           END








